/* *****************************************************************************
 * p7servtest/client.c -- p7servtest virtual client.
 * Copyright (C) 2017 Thomas "Cakeisalie5" Touhey <thomas@touhey.fr>
 *
 * This file is part of p7utils.
 * p7utils is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2.0 of the License,
 * or (at your option) any later version.
 *
 * p7utils is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with p7utils; if not, see <http://www.gnu.org/licenses/>.
 * ************************************************************************** */
#include "main.h"
#include <libp7.h>
#include <libp7/packetio.h>
#include <libp7/stream.h>

void run_client(int in, int out)
{
	/* make the handle */
	p7_handle_t *handle = NULL; int err;
	if ((err = p7_fdinit(&handle, P7_ACTIVE | P7_CHECK | P7_TERM, "client",
	  in, out, &p7_default_settings))) {
		fprintf(stderr, "Client initialization encountered an error: %s\n",
			p7_strerror(err));
		return ;
	}

	/* change working directory. */
	p7_seven_send_cmdfls_cwd(handle, "oui", "fls0");
	p7_seven_send_cmdfls_cwd(handle, "non", "fls0");

	/* we're done. */
	p7_exit(handle);
}
